/*
 * MATRYCA_1.c
 *
 *  Created on: 12-04-2015
 *      Author: Marek
 */
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "fonty.h"
#include "MATRYCA_1.h"





//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void Port_Init(void)                         //funkcja inicjalizacji pinw i portw
{
	        ROW1234 |=ROW1234_MASK;
	        ROW5678 |=ROW5678_MASK;
	        ROWPORT1234 |=ROW1234_MASK;
	        ROWPORT5678 |=ROW5678_MASK;
	        ROW1234 |=ROW1234_MASK;
	        ROW5678 |=ROW5678_MASK;
	      	ROWPORT1234 |=ROW1234_MASK;
	        ROWPORT5678 |=ROW5678_MASK;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void Timer0_Init(void)       //wczenie Timera 0
{
	TCCR0 |= (1<<WGM01);    //tryb CTC
	TCCR0 |= (1<<CS02);     //preskaler 256
	OCR0 = 100;             //warto rejestru dla 400Hz
	TIMSK |= (1<< OCIE0);   //zezwolenie na przerwanie
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void SPI_Init(void)                       //inicjalizacja moduu SPI
{
	DATA |=DANE|CLK |LATCH;
	SPCR|=(1<<SPE)|(1<<MSTR)|(1<<SPI2X)|(1<<DORD);  //tryb master, fosc/2

}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void Send_SPI(uint8_t a )                  //funkcja wysyajca pojedynczy bajt
{
	SPDR=a;
	while(!(SPSR&(1<<SPIF)));

		LATCH_ON;
		LATCH_OFF;
}




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void Send_Row(uint8_t RowNumber)
{
	uint8_t buf;

	for(uint8_t i=0; i<12; ++i)
	{
		buf=0;
		for(uint8_t k=0; k<8; ++k)
		{
			buf |=((display[k+i*8]>>RowNumber)&0x01)<<k;
		}

		Send_SPI(buf);
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void Row_Off(void)                                   //funkcja wygaszajca wiersze
{
	 ROWPORT1234 |=(ROW1|ROW2|ROW3|ROW4);
	 ROWPORT5678 |=(ROW5|ROW6|ROW7|ROW8);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void putChar(uint8_t x, char c, uint8_t  *buf)
{
	for(uint8_t col=0; col<5; ++col)
	{
		*(buf + x + col)= pgm_read_byte (font5x8 + (c - ' ') * 5 + col);
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void putStringP(uint8_t x, const char * s, uint8_t * buf)
{
	 char c;

	while (( c = pgm_read_byte (s++)))
	{
		putChar(x, c, buf);
		x += 7; //odstp liter
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
